/* $Id: vram.h,v 1.1.1.1 1999/01/30 06:09:06 andrewk Exp $
 ******************************************************************************
 * 
 * piocons - PSX PIO console utility for linux
 * Copyright (C) 1997,1998 by "The PIOCONS Team" (see AUTHORS)
 * All Rights Reserved.
 * 
 ******************************************************************************

	interface not finished yet. the output/input picture format is guessed
	or taken from the file extension.

 */

#ifndef __VRAM_H__
#define __VRAM_H__

#include "defs.h"
#include "pio.h"

#define VRAM_FORMAT_16 0
#define VRAM_FORMAT_24 1

typedef struct {
	u_short x,y;
	u_short w,h;
	u_short *pixel;			// pointer to width*height pixels.
	u_short f;				// 16=0,24=1 bit
} vram_image_t;

typedef struct _vram_format_t {

	struct _vram_format_t *next;

	char *name;				// "TIM"
	char *version;			// "0.1"
	char *description;		// "tim image driver"
	char *copyright;		// "Daniel Balster <dbalster@uni-paderborn.de>"
	char *author;			// "Daniel Balster <dbalster@uni-paderborn.de>"

	bool (*detect)(char *filename);

	void (*write) (char *filename, vram_image_t *image);
	void (*read) (char *filename, vram_image_t *image);

} vram_format_t;

extern vram_format_t *vram;

/** prototypes **/

void vram_add_format (vram_format_t *m);
vram_image_t *vram_new_image (void);
void vram_delete_image (vram_image_t *img);
vram_format_t *vram_detect (char *filename);
void vram_list (void);

void vram_operation (u_short x,u_short y,u_short w,u_short h,u_short f,char *filename,bool upload);

#endif  __VRAM_H__
